% PROVIDE - farmers survey 2017-09-06

clear all
clc

global B_backup;


%% ****************************  loading data  ****************************


EstimOpt.fnameinput = ('provide_data_1234.mat');
DATA = load(EstimOpt.fnameinput);


%% ****************************  data transformations  ****************************


% Extend choice tasks data for the pooled model
fields = fieldnames(DATA);
DCE = DATA.DCE;
NP = size(DCE,1)/87;
for i = 1:numel(fields)-1
    tmp = DATA.(fields{i});
    tmp = reshape(tmp,[87,NP]);
    tmp1 = tmp(1:24,:);
    tmp2 = NaN(4,3,NP);
    tmp2(1:3,:,:) = reshape(tmp(25:33,:),[3,3,NP]);
    tmp2 = reshape(tmp2,[4*3,NP]);    
    tmp3 = NaN(4,3,NP);
    tmp3(1:2,:,:) = reshape(tmp(34:39,:),[2,3,NP]);
    tmp3 = reshape(tmp3,[4*3,NP]);
    tmp4 = NaN(4,3,NP);
    tmp4(1:2,:,:) = reshape(tmp(40:45,:),[2,3,NP]);
    tmp4 = reshape(tmp4,[4*3,NP]);
    tmp5 = NaN(4,3,NP);
    tmp5(1:2,:,:) = reshape(tmp(46:51,:),[2,3,NP]);
    tmp5 = reshape(tmp5,[4*3,NP]);
    tmp6 = NaN(4,3,NP);
    tmp6(1:2,:,:) = reshape(tmp(52:57,:),[2,3,NP]);
    tmp6 = reshape(tmp6,[4*3,NP]);
    tmp7 = NaN(4,3,NP);
    tmp7(1:2,:,:) = reshape(tmp(58:63,:),[2,3,NP]);
    tmp7 = reshape(tmp7,[4*3,NP]);
    tmp8 = tmp(64:87,:);          
    tmp = [tmp1;tmp2;tmp3;tmp4;tmp5;tmp6;tmp7;tmp8];
    DATA.(fields{i}) = tmp(:);
end
clear fields DCE NP i tmp tmp1 tmp2 tmp3 tmp4 tmp5 tmp6 tmp7 tmp8

DATA.time = DATA.time - 1;

DATA.SQ = zeros(size(DATA.RANK));
DATA.SQ(DATA.DCEver == 1 & DATA.ALT == 4) = 1;
DATA.SQ(DATA.DCEver == 2 & DATA.ALT == 3) = 1;
DATA.SQ(DATA.DCEver > 3 & DATA.DCEver < 8 & DATA.ALT == 2) = 1;
DATA.SQ(DATA.DCEver == 8.4 & DATA.ALT == 4) = 1;
DATA.SQ(DATA.DCEver == 8.3 & DATA.ALT == 3) = 1;
DATA.SQ(DATA.DCEver == 8.2 & DATA.ALT == 2) = 1;

DATA.DJP = zeros(size(DATA.RANK));
DATA.DJP(DATA.DCEver == 8.4 & DATA.ALT == 1) = 0.5;
DATA.DJP(DATA.DCEver == 8.4 & DATA.ALT == 2) = 1;
DATA.DJP(DATA.DCEver == 8.4 & DATA.ALT == 3) = 1.5;
DATA.DJP(DATA.DCEver == 8.3 & DATA.ALT == 1) = 0.5;
DATA.DJP(DATA.DCEver == 8.3 & DATA.ALT == 2) = 1;
DATA.DJP(DATA.DCEver == 8.2 & DATA.ALT == 1) = 0.5;

DATA.ha = DATA.fZ_A_1./DATA.fZ_B_1;
DATA.DJP_red_15 = DATA.fZ_A_1 - 1.5*DATA.ha;
DATA.DJP_red_10 = DATA.fZ_A_1 - 1.0*DATA.ha;
DATA.DJP_red_05 = DATA.fZ_A_1 - 0.5*DATA.ha;

DATA.DJP_red = nansum([DATA.DJP_red_15.*(DATA.DJP==1.5), DATA.DJP_red_10.*(DATA.DJP==1.0), DATA.DJP_red_05.*(DATA.DJP==0.5)],2);

DATA.sA3_animal = (DATA.sA3 == 5 | DATA.sA3 == 6 | DATA.sA3 == 7 | DATA.sA3 == 8);
DATA.sA3_crop = (DATA.sA3 == 1 | DATA.sA3 == 3);
DATA.sA3_mix = (DATA.sA3 == 4 | DATA.sA3 == 10);

DATA.DJP_norm = DATA.fZ_A_1 ./ nanstd(DATA.fZ_A_1);
DATA.DJP_norm = DATA.DJP_norm - nanmean(DATA.DJP_norm);

DATA.ha_norm = DATA.fA4_1 ./ nanstd(DATA.fA4_1);
DATA.ha_norm = DATA.ha_norm - nanmean(DATA.ha_norm);

DATA.DJP_ha_norm = DATA.fZ_A_1 ./ DATA.fA4_1;
DATA.DJP_ha_norm = DATA.DJP_ha_norm ./ nanstd(DATA.DJP_ha_norm);
DATA.DJP_ha_norm = DATA.DJP_ha_norm - nanmean(DATA.DJP_ha_norm);

DATA.crops_norm = DATA.fA8_1 ./ nanstd(DATA.fA8_1);
DATA.crops_norm = DATA.crops_norm - nanmean(DATA.crops_norm);

DATA.arable_norm = DATA.fA5a_1 ./ nanstd(DATA.fA5a_1);
DATA.arable_norm = DATA.arable_norm - nanmean(DATA.arable_norm);

DATA.sA10(DATA.sA10==998) = NaN;
DATA.sA11(DATA.sA11==998) = NaN;

DATA.sE2_3_praca_w(DATA.sE2_3_praca_w == 998) = NaN;
DATA.sE2_4_praca_w(DATA.sE2_4_praca_w == 998) = NaN;
DATA.work_force_norm = nansum([DATA.sE2_1_praca_w, DATA.sE2_2_praca_w, DATA.sE2_3_praca_w, DATA.sE2_4_praca_w, DATA.sE2_5_praca_w, DATA.sE2_6_praca_w, DATA.sE2_7_praca_w, DATA.sE2_8_praca_w, DATA.sE2_9_praca_w, DATA.sE2_10_praca_w],2);
DATA.work_force_norm = DATA.work_force_norm ./ nanstd(DATA.work_force_norm);
DATA.work_force_norm = DATA.work_force_norm - nanmean(DATA.work_force_norm);

DATA.HHsize_norm = DATA.fE1_1 ./ nanstd(DATA.fE1_1);
DATA.HHsize_norm = DATA.HHsize_norm - nanmean(DATA.HHsize_norm);

DATA.know_birds = NaN(size(DATA.DCE));
DATA.know_birds(DATA.sC6_1_1 == 1) = 1;
DATA.know_birds(DATA.sC6_1_2 == 1) = 2;
DATA.know_birds(DATA.sC6_1_3 == 1) = 3;
DATA.know_birds(DATA.sC6_1_4 == 1) = 4;
DATA.know_birds(DATA.sC6_1_5 == 1) = 5;
DATA.know_birds_norm = DATA.know_birds ./ nanstd(DATA.know_birds);
DATA.know_birds_norm = DATA.know_birds_norm - nanmean(DATA.know_birds_norm);
DATA.know_AE_birds = NaN(size(DATA.DCE));
DATA.know_AE_birds(DATA.sC6_2_1 == 1) = 1;
DATA.know_AE_birds(DATA.sC6_2_2 == 1) = 2;
DATA.know_AE_birds(DATA.sC6_2_3 == 1) = 3;
DATA.know_AE_birds(DATA.sC6_2_4 == 1) = 4;
DATA.know_AE_birds(DATA.sC6_2_5 == 1) = 5;
DATA.know_AE_birds_norm = DATA.know_AE_birds ./ nanstd(DATA.know_AE_birds);
DATA.know_AE_birds_norm = DATA.know_AE_birds_norm - nanmean(DATA.know_AE_birds_norm);

DATA.rec_birds = zeros(size(DATA.DCE));
DATA.rec_birds = DATA.rec_birds + (DATA.sC7a == 3) + (DATA.sC7b == 1) + (DATA.sC7c == 2) + (DATA.sC7d == 2) + (DATA.sC7e == 1) + (DATA.sC7f == 1);

DATA.Y = DATA.RANK == 1;
DATA.Y_missing = repmat(sum(reshape(DATA.Y,[4,size(DATA.Y,1)/4])) ~= 1,[4,1]);
DATA.Y_missing = DATA.Y_missing(:);


%% ****************************  model specification  ****************************


% Model 1:
EstimOpt.ProjectName = 'baseline';
EstimOpt.WTP_space = 1;

DATA.Xa = [(DATA.ALT==1).*(DATA.DCE==1), ...
(DATA.ALT==2).*(DATA.DCE==1), ...
(DATA.ALT==3).*(DATA.DCE==1), ...
(DATA.ALT==1).*(DATA.DCE==2), ... 
(DATA.ALT==2).*(DATA.DCE==2), ... 
(DATA.ALT==1).*(any(DATA.DCE == [3,4,5,6,7],2)),... 
DATA.DJP_red.*(DATA.DCE == 8), ...
(DATA.ALT==1).*DATA.time.*(DATA.DCE==1),...
(DATA.ALT==2).*DATA.time.*(DATA.DCE==1),...
(DATA.ALT==3).*DATA.time.*(DATA.DCE==1),...
(DATA.ALT~=3).*DATA.time.*(DATA.DCE==2),...
(DATA.ALT==1).*DATA.time.*(any(DATA.DCE == [3,4,5,6,7],2)),...
DATA.time.*(DATA.DCE == 8),...
DATA.cancel.*(DATA.DCE == 1).*(DATA.ALT==1),...
DATA.cancel.*(DATA.DCE == 1).*(DATA.ALT==2),...
DATA.cancel.*(DATA.DCE == 1).*(DATA.ALT==3),...
DATA.cancel.*(DATA.DCE == 2).*(DATA.ALT~=3),...
DATA.cancel.*(any(DATA.DCE == [3,4,5,6,7],2)),...
DATA.cancel.*(DATA.DCE == 8),...
DATA.subsidy/4/100];
EstimOpt.NamesA = {...
    'Fertilization';...
    'Diversification';...
    'Catch crops';...
    'Basic protection of peatlands';
    'Extended protection of peatlands';...
    'Extensive meadow use';...
    'Livestock reduction';
    'Length - Fertilization';...
    'Length - Diversification';...
    'Length - Catch crops';...
    'Length - Protection of peatlands';...
    'Length - Extensive meadow use';...
    'Length - Livestock reduction';...
    'Possibility to cancel - Fertilization';...
    'Possibility to cancel - Diversification';...
    'Possibility to cancel - Catch crops';...
    'Possibility to cancel - Protection of peatlands';...
    'Possibility to cancel - Extensive meadow use';...
    'Possibility to cancel - Livestock reduction';...
    'Subsidy (100 EUR/ha/year)'};

DATA.Xs = [DATA.DCE==2, any(DATA.DCE == [3,4,5,6,7],2), DATA.DCE == 8];
EstimOpt.NamesS = {'DCE2';'DCE3-7';'DCE8'};

% Model 2:
% EstimOpt.ProjectName = 'baseline + Xm';
% EstimOpt.WTP_space = 1;
% 
% DATA.Xa = [(DATA.ALT==1).*(DATA.DCE==1), ...
%     (DATA.ALT==2).*(DATA.DCE==1), ...
%     (DATA.ALT==3).*(DATA.DCE==1), ...
%     (DATA.ALT==1).*(DATA.DCE==2), ...
%     (DATA.ALT==2).*(DATA.DCE==2), ...
%     (DATA.ALT==1).*(any(DATA.DCE == [3,4,5,6,7],2)),...
%     DATA.DJP_red.*(DATA.DCE == 8), ...
%     DATA.time-1,...
%     DATA.cancel,...
%     DATA.subsidy/4/100];
% EstimOpt.NamesA = {...
%     'Fertilization';...
%     'Diversification';...
%     'Catch crops';...
%     'Basic protection of peatlands';
%     'Extended protection of peatlands';...
%     'Extensive meadow use';...
%     'Livestock reduction';
%     'Length vs. 1y';...
%     'Possibility to cancel';...
%     'Subsidy (100 EUR/ha/year)'};
% 
% DATA.Xm = [DATA.sA3_crop,DATA.sA3_animal,DATA.arable_norm, DATA.crops_norm, ...
%     DATA.DJP_ha_norm, ...
%     DATA.work_force_norm, DATA.sA10, DATA.sA11, max([DATA.fA12a_1/100, DATA.fA12b_1/100, DATA.fA12c_1/100],[],2),...
%     (DATA.sB0_1 == 1) | (DATA.sB0_1 == 2) | (DATA.sB0_2 == 1) | (DATA.sB0_2 == 2) | (DATA.sB0_3 == 1) | (DATA.sB0_3 == 2),...
%     DATA.know_birds_norm, DATA.know_AE_birds_norm, DATA.rec_birds, DATA.sCZY_OPIS];
% EstimOpt.NamesM = {'Crop prod. (vs. mixed prod.)', 'Livestock prod. (vs. mixed prod.)','Arable land normalized','Number of crops normalized',...
%     'DJP / ha normalized',...
%     'Work force normalized','Farm with streams or rivers','Farm with areas subject to flooding','Share of land in Natura 2000 and National Park',...
%     'Has participated agri-env schemes',...
%     'Subjective bird knowledge normalized', 'Subjective AE practices for birds knowledge normalized', 'Number of birds recognized', 'Info treatment'};
% 
% DATA.Xs = [DATA.DCE==2, any(DATA.DCE == [3,4,5,6,7],2), DATA.DCE == 8];
% EstimOpt.NamesS = {'DCE2';'DCE3-7';'DCE8'};

% Supplementary - disaggregated:
% EstimOpt.WTP_space = 1;
% EstimOpt.ProjectName = 'disagregated';
% 
% DATA.Xa = [(DATA.ALT==1).*(DATA.DCE==1), ...
% (DATA.ALT==2).*(DATA.DCE==1), ...
% (DATA.ALT==3).*(DATA.DCE==1), ...
% (DATA.ALT==1).*(DATA.DCE==2), ... 
% (DATA.ALT==2).*(DATA.DCE==2), ... 
% (DATA.ALT==1).*(any(DATA.DCE == [3,4,5,6,7],2)),... 
% (DATA.DJP==0.5).*DATA.DJP_red.*(DATA.DCE == 8), ...
% (DATA.DJP==1.0).*DATA.DJP_red.*(DATA.DCE == 8), ...
% (DATA.DJP==1.5).*DATA.DJP_red.*(DATA.DCE == 8), ...
% (DATA.ALT==1).*DATA.time.*(DATA.DCE==1),...
% (DATA.ALT==2).*DATA.time.*(DATA.DCE==1),...
% (DATA.ALT==3).*DATA.time.*(DATA.DCE==1),...
% (DATA.ALT==1).*DATA.time.*(DATA.DCE==2),...
% (DATA.ALT==2).*DATA.time.*(DATA.DCE==2),...
% (DATA.ALT==1).*DATA.time.*(any(DATA.DCE == [3,4,5,6,7],2)),...
% (DATA.DJP==0.5).*DATA.time.*(DATA.DCE == 8),...
% (DATA.DJP==1.0).*DATA.time.*(DATA.DCE == 8),...
% (DATA.DJP==1.5).*DATA.time.*(DATA.DCE == 8),...
% DATA.cancel.*(DATA.DCE == 1).*(DATA.ALT==1),...
% DATA.cancel.*(DATA.DCE == 1).*(DATA.ALT==2),...
% DATA.cancel.*(DATA.DCE == 1).*(DATA.ALT==3),...
% DATA.cancel.*(DATA.DCE == 2).*(DATA.ALT==1),...
% DATA.cancel.*(DATA.DCE == 2).*(DATA.ALT==2),...
% DATA.cancel.*(any(DATA.DCE == [3,4,5,6,7],2)),...
% (DATA.DJP==0.5).*DATA.cancel.*(DATA.DCE == 8),...
% (DATA.DJP==1.0).*DATA.cancel.*(DATA.DCE == 8),...
% (DATA.DJP==1.5).*DATA.cancel.*(DATA.DCE == 8),...
% DATA.subsidy/4/100];
% EstimOpt.NamesA = {...
%     'Fertilization';...
%     'Diversification';...
%     'Catch crops';...
%     'Basic protection of peatlands';
%     'Extended protection of peatlands';...
%     'Extensive meadow use';...
%     'Livestock reduction - 0.5';
%     'Livestock reduction - 1.0';
%     'Livestock reduction - 1.5';
%     'Length - Fertilization';...
%     'Length - Diversification';...
%     'Length - Catch crops';...
%     'Length - Protection of peatlands - basic';...
%     'Length - Protection of peatlands - extended';...
%     'Length - Extensive meadow use';...
%     'Length - Livestock reduction - 0.5';...
%     'Length - Livestock reduction - 1.0';...
%     'Length - Livestock reduction - 1.5';...
%     'Possibility to cancel - Fertilization';...
%     'Possibility to cancel - Diversification';...
%     'Possibility to cancel - Catch crops';...
%     'Possibility to cancel - Protection of peatlands - basic';...
%         'Possibility to cancel - Protection of peatlands - extended';...
%     'Possibility to cancel - Extensive meadow use';...
%     'Possibility to cancel - Livestock reduction - 0.5';...
%     'Possibility to cancel - Livestock reduction - 1.0';...
%     'Possibility to cancel - Livestock reduction - 1.5';...
%     'Subsidy (100 EUR/ha/year)'};
% 
% DATA.Xs = [DATA.DCE==2, any(DATA.DCE == [3,4,5,6,7],2), DATA.DCE == 8];
% EstimOpt.NamesS = {'DCE2';'DCE3-7';'DCE8'};

% Supplementary - preference space:
% EstimOpt.ProjectName = 'baseline PS';
% EstimOpt.WTP_space = 0;
% EstimOpt.Dist = [zeros(size(INPUT.Xa,2)-1,1);1];
% 
% DATA.Xa = [(DATA.ALT==1).*(DATA.DCE==1), ...
% (DATA.ALT==2).*(DATA.DCE==1), ...
% (DATA.ALT==3).*(DATA.DCE==1), ...
% (DATA.ALT==1).*(DATA.DCE==2), ... 
% (DATA.ALT==2).*(DATA.DCE==2), ... 
% (DATA.ALT==1).*(any(DATA.DCE == [3,4,5,6,7],2)),... 
% DATA.DJP_red.*(DATA.DCE == 8), ...
% (DATA.ALT==1).*DATA.time.*(DATA.DCE==1),...
% (DATA.ALT==2).*DATA.time.*(DATA.DCE==1),...
% (DATA.ALT==3).*DATA.time.*(DATA.DCE==1),...
% (DATA.ALT~=3).*DATA.time.*(DATA.DCE==2),...
% (DATA.ALT==1).*DATA.time.*(any(DATA.DCE == [3,4,5,6,7],2)),...
% DATA.time.*(DATA.DCE == 8),...
% DATA.cancel.*(DATA.DCE == 1).*(DATA.ALT==1),...
% DATA.cancel.*(DATA.DCE == 1).*(DATA.ALT==2),...
% DATA.cancel.*(DATA.DCE == 1).*(DATA.ALT==3),...
% DATA.cancel.*(DATA.DCE == 2).*(DATA.ALT~=3),...
% DATA.cancel.*(any(DATA.DCE == [3,4,5,6,7],2)),...
% DATA.cancel.*(DATA.DCE == 8),...
% DATA.subsidy/4/100];
% EstimOpt.NamesA = {...
%     'Fertilization';...
%     'Diversification';...
%     'Catch crops';...
%     'Basic protection of peatlands';
%     'Extended protection of peatlands';...
%     'Extensive meadow use';...
%     'Livestock reduction';
%     'Length - Fertilization';...
%     'Length - Diversification';...
%     'Length - Catch crops';...
%     'Length - Protection of peatlands';...
%     'Length - Extensive meadow use';...
%     'Length - Livestock reduction';...
%     'Possibility to cancel - Fertilization';...
%     'Possibility to cancel - Diversification';...
%     'Possibility to cancel - Catch crops';...
%     'Possibility to cancel - Protection of peatlands';...
%     'Possibility to cancel - Extensive meadow use';...
%     'Possibility to cancel - Livestock reduction';...
%     'Subsidy (100 EUR/ha/year)'};
% 
% DATA.Xs = [DATA.DCE==2, any(DATA.DCE == [3,4,5,6,7],2), DATA.DCE == 8];
% EstimOpt.NamesS = {'DCE2';'DCE3-7';'DCE8'};


%% ****************************  specifying input ****************************

DATA.filter = true(size(DATA.DCE));

INPUT.Y = DATA.Y(DATA.filter); 
INPUT.Xa = DATA.Xa(DATA.filter,:);
INPUT.Xs = DATA.Xs(DATA.filter,:);
INPUT.Xm = DATA.Xm(DATA.filter,:); % for Xm

INPUT.MissingInd = any(isnan(INPUT.Xa),2) | DATA.Y_missing; 
INPUT.MissingInd = any(isnan(INPUT.Xa),2) | any(isnan(INPUT.Xm),2) | DATA.Y_missing; % for Xm


%% ****************************  sample characteristics ****************************


EstimOpt.NCT = 6+6+3*5+3;
EstimOpt.NAlt = 4;
EstimOpt.NP = length(INPUT.Y)/EstimOpt.NCT/EstimOpt.NAlt; % numel(unique(DATA.nr))


%% **************************** estimation and optimization options ****************************

EstimOpt.eps = 1.e-6; % overall precision level

[INPUT, Results, EstimOpt, OptimOpt] = DataCleanDCE(INPUT,EstimOpt);

EstimOpt.NRep = 1e4; % number of draws for numerical simulation
% OptimOpt.MaxIter = 1e1; % maximum number of iterations
% OptimOpt.Algorithm = 'trust-region'; % 'quasi-newton';
% EstimOpt.NumGrad = 1; % 1
% OptimOpt.GradObj = 'off'; % 'off'
% OptimOpt.FinDiffType = 'central'; % 'forward'
% OptimOpt.Hessian = 'user-supplied'; % 'off'
% EstimOpt.HessEstFix = 1; % 0 = use optimization Hessian, 1 = use jacobian-based (BHHH) Hessian, 2 - use high-precision jacobian-based (BHHH) Hessian 3 - use numerical Hessian
% EstimOpt.ApproxHess = 0;
% EstimOpt.RealMin = 1;


try
    

%% ****************************     MNL     ****************************


% baseline 1y:
B_backup = [0.0192488539619085;-0.983019959059962;-0.525991203951208;0.248690206358963;-0.481841938089924;-0.371506094946704;-0.217503569069083;-0.201090003927774;-0.225655475799851;-0.212592397788698;-0.0814454535013684;-0.146508800250059;-0.529298804281626;0.296166074012976;0.863038442453425;0.961785394303760;-0.00588421937581039;0.431568512334790;0.579665600721941;0.535937802974526;0.250480822150843;0.303633822826990;-1.39271596599542];

% baseline simplified: 
% B_backup = [-0.0653590401720289;-0.824108610598985;-0.290702784674551;1.58021041515768;0.618840630929037;0.191783561301277;-0.244977634340996;-0.190685267049171;0.531284823613149;0.585284079350868;-0.280700458101367;-0.00228277248637350;-1.34663429921000];
% baseline simplified + Xm: 
% B_backup = [B_backup; zeros(size(INPUT.Xa,2).*size(INPUT.Xm,2),1)];

% disaggregated:
% B_backup =  [0.0192475374078295;-0.983025628388819;-0.525985834390573;0.434283756203803;-0.707204808476003;-0.371505943234085;-0.282507595098131;-0.278085297412156;-0.152891383331921;-0.201090119429418;-0.225655624141319;-0.212592639262248;-0.0931013992803715;-0.0660488131475740;-0.146508797681062;-0.409697033251464;-0.856554434481545;-0.471291406266391;0.296170387264999;0.863049032072586;0.961779453622900;-0.171509138893872;0.216945297838353;0.431568158229691;-0.530123875697117;1.56214066983951;1.25550552664259;0.535937423628522;0.236929836963050;0.303634664930311;-1.39567251351542];

% baseline 1y PS:
% B_backup = [0.0103131654780341;-0.526844399180213;-0.281906237273422;0.133279639004567;-0.258243211221876;-0.199108768366295;-0.116569077344080;-0.107771891049483;-0.120937345338773;-0.113936422067839;-0.0436497055465503;-0.0785198473326531;-0.283673076781237;0.158721457145349;0.462534714354264;0.515459689966045;-0.00315365971126122;0.231297299555913;0.310657122968027;0.535940655130442;0.250474517135090;0.303630976397677;-1.39272441089655];

OptimOpt.Algorithm = 'trust-region'; % 'quasi-newton';
OptimOpt.Hessian = 'user-supplied'; % 'off'

Results.MNL = MNL(INPUT,Results,EstimOpt,OptimOpt);

OptimOpt.Algorithm = 'quasi-newton';
OptimOpt.Hessian = 'off';

Results.MNL = MNL(INPUT,Results,EstimOpt,OptimOpt);


%% ****************************     MXL_d     ****************************


% baseline 1y: 
B_backup = [-0.187602197289879;-1.36101000126141;-0.906898814276689;0.311034100086401;-0.278102354324415;-0.613592982009624;-0.405464076660824;-0.278343591601871;-0.268137940810743;-0.265500627295541;-0.0801187162499030;-0.147476002445035;-0.239436356179822;0.429054723331723;0.713232946573034;1.02844450719847;-0.00969210653981906;0.521115444694207;1.36272409295424;0.00183077184930944;2.22831002359043;2.13087645865512;1.95218235077078;1.18040384196915;1.53968524004381;1.08286912621937;0.772631701315384;0.247376111238932;0.147041053619735;0.212641743861641;0.251621364299545;0.189655138422304;0.215855656832951;1.32688018214478;1.20514713833067;1.49420237573889;-0.997697679394411;0.684928595444427;2.43586109312017;0.587191776863096;0.525121454115987;0.832222121777464;-0.481304589751179];

% baseline simplified: 
% B_backup = [-0.258852235819233;-0.891453910969921;-0.500252032852415;0.939360886297102;0.138617324774300;0.128947324890234;-0.300558553884851;-0.227096154213122;0.581763712305941;0.149158774104579;1.90271612730521;1.72091894106194;1.46198841630498;1.39593095914638;1.58913835342333;1.77832157300951;0.652582677084445;0.206765885297156;1.24557119399733;0.605397275131247;0.0770565907720390;0.141953933022282;-0.636818784317577];
% baseline simplified + Xm: 
% B_backup = [B_backup; zeros(size(INPUT.Xa,2).*size(INPUT.Xm,2),1)];

% disaggregated:
% B_backup = [-0.384928400083040;-1.09359448412305;-1.05737722919623;0.0664451119468838;-0.854363557558702;-0.596088285732957;-0.508882307537232;-0.543525181824164;-0.292086262069928;-0.279976569596056;-0.295373403561099;-0.259027221937997;-0.136904973013374;-0.101557383001141;-0.151364667488181;-0.324504078595692;-0.433762624363194;-0.665079958628526;0.298710577312681;0.608034816892456;0.981560761846036;0.0122780696072077;0.127108978342679;0.365222826192528;0.608488804903727;1.03374355909017;0.0777251834811263;0.0864231276596829;2.07342054711400;1.98106112083296;1.77894170970841;-0.454604714400932;1.49327583826753;1.30727771873246;0.951302307393432;0.873520932891535;0.865007230471577;0.222734974297417;0.199494602272328;0.181315639371070;0.193475742248532;0.124940983750126;0.148339989114944;0.457078594308132;0.200471743110801;0.526399480194826;1.19824371756891;1.58489049165007;1.40825540377212;0.299393624291391;-0.411415954215974;0.549169515178451;0.882127627102555;2.87468463368446;1.38458594477656;0.838517863383443;0.345125105971635;0.796172106336940;-0.553424598922792];

% baseline 1y PS: 
% B_backup = [-0.462718945463757;-1.13099699345401;-0.846983523984050;0.0485929219896873;-0.920437041448821;-0.733765019330108;-0.467599464936202;-0.322978747920841;-0.372927567524394;-0.352513994832234;-0.117781076874957;-0.194865467162199;-0.332613396411251;0.546212595413925;0.875109499629131;1.09298311021596;0.115430869634043;0.563142311442268;1.51597843629645;0.167310380778719;1.97693366820932;1.65213688930387;1.16778323989390;1.35397426840189;1.99382515207444;1.67746603754516;0.636353125097079;0.226301726106075;0.194290001894106;0.243383206218991;0.171355817212843;0.200167960239931;0.304360970028943;1.49994998356221;1.15140968632557;1.70509142521424;1.69285614457072;0.709076327094584;3.83754596665448;0.854815412909196;0.0963725135002500;0.355197215681198;-0.869232392000757];


OptimOpt.Algorithm = 'trust-region'; % 'quasi-newton';
OptimOpt.Hessian = 'user-supplied'; % 'off'

Results.MXL_d = MXL(INPUT,Results,EstimOpt,OptimOpt); 

OptimOpt.Algorithm = 'quasi-newton';
OptimOpt.Hessian = 'off';

Results.MXL_d = MXL(INPUT,Results,EstimOpt,OptimOpt); 


sendmail('mik@czaj.org','MATLAB: D5 - done!');
    
catch theErrorInfo
    
sendmail('mik@czaj.org','MATLAB: D5 - error!');
rethrow(theErrorInfo)

end